#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <string>
#include <time.h>

#include "rts_forest.hpp"
#include "common.h"
//Af, ŏ@gp

int main(int argc, char *argv[]){

	//
	// Tvf[^̓ǂݍ
	//
	RTs::Sample samp_tmp;
	samp_tmp.feature_vec.resize(INPUT_DIM_SIZE);
	samp_tmp.label_vec = 0.0;
	std::vector<RTs::Sample> samples;

	std::stringstream ss;
	ss << "../resrc/train_linear.txt";
	std::ifstream ifs(ss.str().c_str());

	if(!ifs){
		std::cout << "t@CJ܂ : " << ss.str().c_str() << std::endl;
		exit(-1);
	}

	int samp_num = 0;

	std::cout << "Import samples\n";
	while(!ifs.eof()){
		double tmp;
		RTs::Sample sample;
		sample.label_vec = 0.0;
		sample.feature_vec.resize(INPUT_DIM_SIZE);

		ifs >> tmp;
		sample.label_vec = tmp;
		for(int i=0; i<INPUT_DIM_SIZE; i++){
			ifs >> tmp;
			sample.feature_vec[i] = tmp;
		}
		if(ifs.fail()){
			break;
		}
		//TvzɊi[
		samples.push_back(sample);
		samp_num++;
		//printf("sample num = %d, num[%d] = %d\r", samp_num, tmp_rand, num[tmp_rand]);
	}
	std::cout << std::endl;
	std::cout << "sample num = " << samp_num << std::endl;
	std::cout.flush();

	//
	// Randomized Forest 
	//
	//  numTrees = 5
	//  maxDepth = 10
	//  featureTrials = 50
	//  thresholdTrials = 5
	//  dataPerTree = .25f
	//

	RTs::Forest rts_forest;
	if(rts_forest.Learn(5, 5, 9, 5, .5f, samples) == false){
		std::cerr << "RTs::Forest::Learn() failed." << std::endl;
		std::cerr.flush();
		return 1;
	}

	//
	// wKʂ̕ۑ
	//

	if(rts_forest.Save("../Regression_Forests.txt") == false){
		std::cerr << "RTs::Forest::Save() failed." << std::endl;
		std::cerr.flush();
		return 1;
	}
	std::cout << "finish!\n";
	return 0;
}
