#include <math.h>
#include <string.h>
#include <float.h>
#include <stdlib.h>

#include <iostream>
#include <fstream>
#include <vector>
#include <string>

#include "rts_feature.hpp"
#include "rts_sample.hpp"
#include "rts_node.hpp"
#include "rts_tree.hpp"
#include "rts_forest.hpp"

namespace RTs{


/*!
@brief RXgN^
*/

Forest::Forest(){
	numTrees = 0;
	maxDepth = 0;
	featureTrials = 0;
	thresholdTrials = 0;
	dataPerTree = 0;
	prediction = 0.0;
}


/*!
@brief fXgN^
*/

Forest::~Forest(){
}


/*!
@brief tMɂ Randomized Forest 𐶐֐D
@param[in] _numClass ʂNX
@param[in] _numTrees ؂̐
@param[in] _maxDepth ؂̊Kw̍ő吔
@param[in] _featureTrials ʃ_I̎s
@param[in] _thresholdTrials l_I̎s
@param[in] _dataPerTree X̌؂ɎgtM̃TuZbg̊
@param[in] samples tM
@return succeed or not
*/

bool Forest::Learn(const int _numTrees,
                   const int _maxDepth,
                   const int _featureTrials,
                   const int _thresholdTrials,
                   const float _dataPerTree,
                   std::vector<Sample> &samples){

	numTrees = _numTrees;
	maxDepth = _maxDepth;
	featureTrials = _featureTrials;
	thresholdTrials = _thresholdTrials;
	dataPerTree = _dataPerTree;
	for(unsigned int t=0; t<trees.size(); ++t){
		delete trees[t];
	}
	trees.clear();

	// Tree 󂯕t̂ "Sample *"  vector Ȃ̂ŁC|C^ vector 𐶐
	std::vector<const Sample *> samples_pointers(samples.size());
	for(unsigned int s=0; s<samples.size(); ++s){
		samples_pointers[s] = &samples[s];
	}

	for(int t=0; t<numTrees; ++t){

		// ؂Vɍ쐬
		trees.push_back(new Tree());

		// ̌؂̂߂̃TuZbgwKf[^𐶐
		std::vector<const Sample *> subset_samples_pointers((int)(samples_pointers.size()*dataPerTree + .5));
		for(unsigned int s=0; s<subset_samples_pointers.size(); ++s){
			subset_samples_pointers[s] = samples_pointers[rand()%samples_pointers.size()];
		}

		// TuZbggČ؂wK
		if(trees.back()->BuildTree(maxDepth, featureTrials, thresholdTrials,
		                        subset_samples_pointers) == false){
								//samples_pointers) == false){

			// G[F؂̊wKɉG[N͗l
			for(unsigned int t=0; t<trees.size(); ++t){
				delete trees[t];
			}
			trees.clear();
			return false;
		}

		// ؂̖[m[h̗\쐬
		if(trees.back()->BuildLeaf(samples_pointers) == false){
			// G[FqXgO쐬ɉG[N͗l
			for(unsigned int t=0; t<trees.size(); ++t){
				delete trees[t];
			}
			trees.clear();
			return false;
		}

	}

	return true;
}



/*!
@brief ʑΏۂ̓xNgCΉ\߂D
@param[in] feature_vec ʂʃxNg
return histogram
*/

double Forest::EstimateClass(const Feature &feature_vec){

	if(trees.empty()){
		// G[F؂쐬ĂȂ
		return NULL;
	}
	
	prediction = 0.0;

	for(unsigned int t=0; t<trees.size(); ++t){
		prediction += trees[t]->Traversal(feature_vec);
		
		if(prediction == NULL){
			// G[F؂ǂߒŃG[͗l
			return NULL;
		}
	}

	//ς̎Zo
	prediction = prediction / (double)trees.size();

	return prediction;
}


/*!
@brief Forest Ŝۑ
@param[in] filename t@C
@return succeed or not
*/

bool Forest::Save(const std::string &filename){

	if(trees.empty()){
		// G[F؂쐬ĂȂ
		return false;
	}

	std::ofstream ofs(filename.c_str());
	if(ofs.fail()){
		return false;
	}

	// ܂ Forest ̃p[^ۑ
	ofs << numTrees << " "
	    << maxDepth << " "
	    << featureTrials << " "
	    << thresholdTrials << " "
		<< dataPerTree << std::endl;
	if(ofs.fail()){
		return false;
	}

	for(unsigned int t=0; t<trees.size(); ++t){
		// e Tree ̏ۑ
		if(trees[t]->Save(ofs) == false){
			return false;
		}
	}

	return true;
}


/*!
@brief Forest Ŝǂ݂
@param[in] filename t@C
@return succeed or not
*/

bool Forest::Load(const std::string &filename){

	for(unsigned int t=0; t<trees.size(); ++t){
		delete trees[t];
	}
	trees.clear();

	std::ifstream ifs(filename.c_str());
	if(ifs.fail()){
		std::cout << "t@CJ܂" << filename.c_str() << std::endl;
		return false;
	}

	// ܂ Forest ̃p[^ǂݍ
	ifs >> numTrees
	    >> maxDepth
	    >> featureTrials
	    >> thresholdTrials
		>> dataPerTree;
	if(ifs.fail()){
		std::cout << "Forests̃p[^ǂݍ߂܂\n";
		return false;
	}

	for(int t=0; t<numTrees; ++t){

		// ؂Vɍ쐬
		trees.push_back(new Tree());

		// Tree ̏ǂݍ
		if(trees.back()->Load(ifs) == false){
			return false;
		}
	}

	return true;
}


} // namespace RTs
