#ifndef _RTS_TREE_HPP_
#define _RTS_TREE_HPP_

#include "rts_feature.hpp"
#include "rts_sample.hpp"
#include "rts_node.hpp"

namespace RTs{

//
// RTs::Tree ...  (Tree) ̃NXD
//

class Tree{
private:
	Node *root;

	//	AWZo
	std::vector<double> multipleRegression(const std::vector<const Sample *> &samples);

	// ċA Tree (= Node ̊Kw) 𐶐DwK̃CD
	Node *build(const int maxDepth,
	            const int featureTrials,
	            const int thresholdTrials,
	            const std::vector<const Sample *> &samples,
	            const int depth);

	// ċAŊwKf[^Ė[m[hTCǂ蒅[m[h̃qXgOɓ[D
	bool voteSample(const Sample *  &sample,
	                    Node *node);

	// ċAŖ[m[hTCǂ蒅[m[h̗\𐳋KD
	bool normalizeLeaf(Node *node);

	// ċAŖ[m[hTCǂ蒅[m[h̃qXgOԂDʏɑD
	double traversal(Node *node,
	                       const Feature &featur_vec);

	// ċAŃm[hۑ
	bool save(std::ofstream &ofs,
	          Node *node);

	// ċAŃm[hǂݍ
	Node *load(std::ifstream &ifs);

public:
	// RXgN^
	Tree();

	// fXgN^
	~Tree();

	// w肳ꂽp[^ŊwKf[^ Tree 𐶐DċA build() sN_D
	bool BuildTree(const int maxDepth,
	               const int featureTrials,
	               const int thresholdTrials,
	               const std::vector<const Sample *> &samples);

	// \zς݂ Tree \ɑ΂ĊwKf[^^C\𐶐D
	// voteSample(), normalizeLeaf() sD
	bool BuildLeaf( std::vector<const Sample *> &samples);

	// ʑΏۂ̓xNgCΉqXgO߂DċA traversal() sN_D
	double Traversal(const Feature &feature_vec);

	// Tree ۑDċA save() sN_D
	bool Save(std::ofstream &ofs);

	// Tree ǂݍށDċA load() sN_D
	bool Load(std::ifstream &ifs);
};

} // namespace RTs

#endif // _RTS_TREE_HPP_
